/* MCVE v3.x C API
   (c) 2002 by Main Street Softworks, Inc.
   Written by Brad House

   This API is being released to the public domain to be modified and used in any manor the holder of this code sees fit.
   For any questions please contact  support@mainstreetsoftworks.com
*/

#include "libmcve_main.h"
#include "mcve.h"

long MCVE_Count_CD_Lines(MCVE_CONN *myconn, long identifier)
{
  _MCVE_CONN *conn=(_MCVE_CONN *)myconn[0];
  char *temp, *str;
  long cnt=0;

  if (conn->queue[identifier].response == NULL) return(0);
  str=conn->queue[identifier].response;
  while (1) {
    temp=strstr(str, "\r\n");
    if (temp == NULL) break;
    cnt++;
    str=temp+2;
  }
  return(cnt);
}

char *MCVE_Get_CD_Line(char *string)
{
  char *temp;
  int len;
  if (string == NULL) return(NULL);
  temp=strstr(string, "\r\n");
  if (temp == NULL) return(NULL);
  len=strlen(string)-strlen(temp);
  return(MCVE_midstr(string, 0, len));
}

int MCVE_Count_CD_Columns(MCVE_CONN *myconn, long identifier)
{
  _MCVE_CONN *conn=(_MCVE_CONN *)myconn[0];
  char *temp;
  char *line, *str;
  int cnt=1;

  line=MCVE_Get_CD_Line(conn->queue[identifier].response);
  if (line == NULL) return(0);
  str=line;
  while (1) {
    temp=strchr(str, ',');
    if (temp == NULL) break;
    str=temp+1;
    cnt++;
  }
  free(line);
  return(cnt);
}

