#ifndef __LIBMCVE_SNPRINTF__
#define __LIBMCVE_SNPRINTF__

#include <stdarg.h>
#include <sys/ioctl.h>
#include <sys/param.h>
#include "mcve.h"

/*
 * We do all internal arithmetic in the widest available integer type,
 * here called long_long (or ulong_long for unsigned).
 */
#ifndef NO_LONG_LONG
typedef long long long_long;
typedef unsigned long long ulong_long;
#else
typedef long long_long;
typedef unsigned long ulong_long;
#endif


/* SNPRINTF REPLACEMENT CALLS */
int MCVE_snprintf(char *str, size_t count, const char *fmt,...);
int MCVE_vsnprintf(char *str, size_t count, const char *fmt, va_list args);
int MCVE_vasprintf(char **ret, const char *fmt, va_list args);
int MCVE_asprintf(char **ret, const char *fmt, ...);
int MCVE_vfprintf(FILE *fp, const char *fmt, va_list args);

#endif

