// mcvetest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "mcve.h"

int main(int argc, char* argv[])
{
	MCVE_CONN conn;
    long identifier;

	printf("MCVE WIN32 DEMO\n");
	
	MCVE_InitEngine(NULL);
	MCVE_InitConn(&conn);
	MCVE_SetIP(&conn, "testbox.mcve.com", 8333);
	MCVE_SetBlocking(&conn, 1);
	if (!MCVE_Connect(&conn)) {
	  printf("Could not connect: %s\r\n", MCVE_ConnectionError(&conn));
	  return 1;
	}
	printf("Connected\r\n");

	identifier=MCVE_TransNew(&conn);
	MCVE_TransParam(&conn, identifier, MC_USERNAME, "vitale");
	MCVE_TransParam(&conn, identifier, MC_PASSWORD, "test");
	MCVE_TransParam(&conn, identifier, MC_TRANTYPE, MC_TRAN_SALE);
	MCVE_TransParam(&conn, identifier, MC_ACCOUNT, "4012888888881");
	MCVE_TransParam(&conn, identifier, MC_EXPDATE, "0512");
	MCVE_TransParam(&conn, identifier, MC_AMOUNT, 12.00);
	MCVE_TransSend(&conn, identifier);
	
	if (MCVE_ReturnStatus(&conn, identifier) == MCVE_SUCCESS) {
	  printf("Transaction Successful!\r\n");
	} else {
	  printf("Transaction Failed\r\n");
	}
	printf("Code: %s\r\n", MCVE_TEXT_Code(MCVE_ReturnCode(&conn, identifier)));
	printf("AuthNum: %s\r\n", MCVE_TransactionAuth(&conn, identifier));
	printf("Verbiage: %s\r\n", MCVE_TransactionText(&conn, identifier));
	return 0;
}

